#include<iostream>
#include<vector>
#include<algorithm>
#include<fstream>
#include<string>
#include<cstring>
#include <sstream>

using namespace std;

class CCentroComercial 
{
public:
/*	class LOJA {
	public:
		string nome;
		string tipo;
		int renda;
	} ;*/
	typedef struct {
		string nome;
		string tipo;
		int renda;
	} LOJA;
private:
	vector<LOJA> lojas;
public:
	void ler_lojas(const char *nome);
	void imprimir_lojas(ostream &output, string tipo);
	void imprimir_lojas(ostream &output);
	void ordenarLojas ();

	static bool lojaCompare (CCentroComercial::LOJA& lj1, CCentroComercial::LOJA& lj2);
};

//=================
void CCentroComercial::ler_lojas(const char *nome)
{
	ifstream file(nome);
	if (!file)
	{
		cerr << "erro ao abrir\n";
		return;
	}
	lojas.clear ();

	//SOLUCAO A
	while (1)

	{
		LOJA loja;
		string renda;
		getline (file, loja.nome);
		getline (file, loja.tipo);
		getline (file, renda);
//		if (!file)
            if (file.eof())
			break;
		loja.renda = atoi (renda.c_str());
		lojas.push_back(loja);
	}
	return;
	//SOLUCAO ALTERNATIVA B
	while (1)
	{
		LOJA loja;
		string renda;
		istringstream ss;
		getline (file, loja.nome);
		getline (file, loja.tipo);
		getline (file, renda);
		if (!file)
			break;
		ss.str(renda);
		ss >> loja.renda;
		lojas.push_back(loja);
	}
	return;
}

void CCentroComercial::imprimir_lojas(ostream &output)
{
	for(unsigned int i = 0; i< lojas.size(); i++)
	{
		output << lojas[i].nome <<";"<<lojas[i].tipo << ";" << lojas[i].renda << endl;
	}
}

void CCentroComercial::imprimir_lojas(ostream &output, string tipo)
{
	for(unsigned int i = 0; i< lojas.size(); i++)
	{
		if (lojas[i].tipo == tipo)
			output << lojas[i].nome <<";"<<lojas[i].tipo << ";" << lojas[i].renda << endl;
	}
}
// podia ficar como funo global fora da classe loja
bool CCentroComercial::lojaCompare (CCentroComercial::LOJA& lj1, CCentroComercial::LOJA& lj2)
{
	return lj1.renda < lj2.renda;
}

void CCentroComercial::ordenarLojas ()
{
	vector<LOJA>::iterator it1;
	for(it1 = lojas.begin(); it1 != lojas.end()-1; ++it1 )
	{
		iter_swap(it1, min_element(it1, lojas.end(), lojaCompare) );
	}
}


int main(int argc, char **argv)
{
	CCentroComercial cc;
	cc.ler_lojas("centroComercial.txt");
	cc.imprimir_lojas(cout);
	cc.ordenarLojas();
	cc.imprimir_lojas(cout);
	cc.imprimir_lojas(cout,"Sapatos");
	return 0;
}
