#include<iostream>
#include<vector>
#include<algorithm>
#include<fstream>
#include<string>
#include <sstream>
#include<cstring>
#include<ctime>
using namespace std;

class CJogoMedieval {
public:
	/*class CHARACTER {
	public:
		string tipo; // "monster" or "player"
		int health;
		int strength;
		double x;
		double y;
	};*/
	typedef struct {
		string tipo; // "monster" or "player"
		int health;
		int strength;
		double x;
		double y;
	} CHARACTER;
private:
	vector<CHARACTER> characters;
	int activeCharacter;
public:
	CJogoMedieval (int nPlayers, int nMonsters);
	CJogoMedieval ();
	void saveGame (const char *filename);
	void loadGame (const char *filename);
	CHARACTER findWeakestMonster(int maxHealth);
};

//=================
CJogoMedieval::CJogoMedieval(int nPlayers, int nMonsters) 
{
	srand (time(0));

	for (int i = 0; i < nPlayers; i++)
	{
		CHARACTER player;
		player.tipo = "player";
		player.health = 100;
		player.strength = 40 + rand()%(100-40+1);
		player.x = rand()*1.0/RAND_MAX;
		player.y = rand()*1.0/RAND_MAX;
		characters.push_back(player);
	}
	for (int i = 0; i < nMonsters; i++)
	{
		CHARACTER monster;
		monster.tipo = "monster";
		monster.health = 100;
		monster.strength = 40 + rand()%(100-40+1);
		monster.x = rand()*1.0/RAND_MAX;
		monster.y = rand()*1.0/RAND_MAX;
		characters.push_back(monster);
	}
	activeCharacter = 0;
}

CJogoMedieval::CJogoMedieval()
{
	activeCharacter = 0;
}

void CJogoMedieval::saveGame (const char * filename)
{
	ofstream file (filename);
	if (!file)
	{
		cerr << "erro ao abrir\n";
		return;
	}
	for (unsigned int i = 0; i < characters.size(); i++)
	{
		file << characters[i].tipo << " " << characters[i].health << " " << characters[i].strength << " " << characters[i].x << " " << characters[i].y << endl; 
	}
}

void CJogoMedieval::loadGame (const char * filename)
{
	ifstream file (filename);
	if (!file)
	{
		cerr << "erro ao abrir\n";
		return;
	}
	characters.clear();

	string character;
	while (getline (file, character))
	{
		istringstream ss;
		ss.str (character);
		CHARACTER ch;
		ss >> ch.tipo >> ch.health >> ch.strength >> ch.x >> ch.y;
		characters.push_back(ch);
	}
}

CJogoMedieval::CHARACTER CJogoMedieval::findWeakestMonster (int maxHealth)
{
	CHARACTER invalidMonster = {"monster", 100, 100, -1, -1};
	CHARACTER ch = invalidMonster;
	for (int i = 0; i < characters.size(); i++)
	{
		if (characters[i].tipo == "player" || characters[i].health > maxHealth)
			continue;
		if (ch.x == invalidMonster.x)
			ch = characters[i];
		if (characters[i].strength < ch.strength)
			ch = characters[i];
	}
	return ch;
}

int main(int argc, char **argv)
{
	CJogoMedieval jm(10, 7);
	jm.saveGame("JogoMedieval.txt");
	CJogoMedieval jm2;
	jm2.loadGame("JogoMedieval.txt");
	jm2.saveGame("JogoMedieval2.txt");
	CJogoMedieval::CHARACTER c = jm2.findWeakestMonster(100);
	cout << c.health << " " << c.strength << " " << c.x << " " << c.y << endl;
	return 0;
}
