#include<iostream>
#include<vector>
#include<algorithm>
#include<fstream>
#include<string>
#include <sstream>
#include<cstring>
#include<ctime>
using namespace std;

class CRadioDespertador
{
public:
	/*class TIME {
	public:
		int h, m, s;
	};*/
	typedef struct {
		int h, m, s;
	} TIME;
private:
	TIME currTime;
	TIME alarm;
	int alarmDuration;
	string stationAlarm;
	vector<string> stationsName;
	vector<double> stationsFrequency;
public:
	int addStation (string name, const char * stationDatabase);
	int removeStation (string name);
	int removeStation (double freq);
	void setTime (int hr, int mn, int sg);
	void setAlarm (int hr, int mn, int sg, int duration, string station);
	int isRinging();
};

//=================
int CRadioDespertador::addStation (string name, const char * stationDatabase)
{
	if (find(stationsName.begin(), stationsName.end(), name) != stationsName.end() )
	{
		cerr << "estacao ja pre-definida\n";
		return -1;
	}
	ifstream file (stationDatabase);
	if (!file)
	{
		cerr << "erro ao abrir\n";
		return -1;
	}
	while (1)
	{
		string curr_name;
		string freq;
		getline (file, curr_name);
		if(!getline (file, freq))
			break;
		if (name == curr_name)
		{
			stationsName.push_back(name);
			stationsFrequency.push_back(atof (freq.c_str()));
			return 0;
		}
	}
	return -1;
}

int CRadioDespertador::removeStation (string name)
{
	vector<string>::iterator it1;
	vector<double>::iterator it2;

	for (it1 = stationsName.begin (), it2 = stationsFrequency.begin(); it1 != stationsName.end(); it1++, it2++)
	{
		if (*it1 == name)
		{
			stationsName.erase(it1);
			stationsFrequency.erase(it2);
			return 0;
		}
	}
	return -1;
}

int CRadioDespertador::removeStation (double freq)
{
	vector<string>::iterator it1;
	vector<double>::iterator it2;

	for (it1 = stationsName.begin (), it2 = stationsFrequency.begin(); it1 != stationsName.end(); it1++, it2++)
	{
		if (*it2 == freq)
		{
			stationsName.erase(it1);
			stationsFrequency.erase(it2);
			return 0;
		}
	}
	return -1;
}

void CRadioDespertador::setTime (int h, int m, int s)
{
	currTime.h = h;
	currTime.m = m;
	currTime.s = s;
}

void CRadioDespertador::setAlarm (int h, int m, int s, int duration,
								  string station)
{
	alarm.h = h;
	alarm.m = m;
	alarm.s = s;
	alarmDuration = duration;
	stationAlarm = station;
}

int CRadioDespertador::isRinging()
{
	int currTimeSec = 3600*currTime.h + 60*currTime.m + currTime.s;
	int alarmSec = 3600*alarm.h + 60*alarm.m + alarm.s;
	
	if (currTimeSec < alarmSec)
		return -1;
	if (currTimeSec > alarmSec + alarmDuration*60)
		return 1;
	return 0;
}

int main(int argc, char **argv)
{
	CRadioDespertador rd;

	cout << rd.addStation("Onda Viva", "radios.txt") << endl;
	cout << rd.addStation("Onda Viva", "radios.txt") << endl;
	
	rd.setAlarm(16, 13, 14, 2, "Onda Viva");
	rd.setTime(16, 14, 24);
	
	cout << rd.isRinging() << endl;
	return 0;
}
